AC_DEFUN([DUMPI_TEST_MPI_CONSTANTS],
  [
    dnl Test whether MPI constants are defined properly
    AC_LANG_PUSH(C)

    AH_TEMPLATE([DUMPI_HAVE_MPI_SUCCESS], [True if MPI_SUCCESS is defined])
    AC_MSG_CHECKING([whether the constant MPI_SUCCESS is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_SUCCESS;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_SUCCESS, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_ANY_TAG], [True if MPI_ANY_TAG is defined])
    AC_MSG_CHECKING([whether the constant MPI_ANY_TAG is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_ANY_TAG;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_ANY_TAG, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_ANY_SOURCE], [True if MPI_ANY_SOURCE is defined])
    AC_MSG_CHECKING([whether the constant MPI_ANY_SOURCE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_ANY_SOURCE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_ANY_SOURCE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_ROOT], [True if MPI_ROOT is defined])
    AC_MSG_CHECKING([whether the constant MPI_ROOT is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_ROOT;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_ROOT, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_NAMED], [True if MPI_COMBINER_NAMED is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_NAMED is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_NAMED;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_NAMED, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_DUP], [True if MPI_COMBINER_DUP is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_DUP is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_DUP;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_DUP, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_CONTIGUOUS], [True if MPI_COMBINER_CONTIGUOUS is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_CONTIGUOUS is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_CONTIGUOUS;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_CONTIGUOUS, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_VECTOR], [True if MPI_COMBINER_VECTOR is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_VECTOR is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_VECTOR;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_VECTOR, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_HVECTOR_INTEGER], [True if MPI_COMBINER_HVECTOR_INTEGER is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_HVECTOR_INTEGER is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_HVECTOR_INTEGER;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_HVECTOR_INTEGER, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_HVECTOR], [True if MPI_COMBINER_HVECTOR is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_HVECTOR is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_HVECTOR;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_HVECTOR, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_INDEXED], [True if MPI_COMBINER_INDEXED is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_INDEXED is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_INDEXED;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_INDEXED, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_HINDEXED_INTEGER], [True if MPI_COMBINER_HINDEXED_INTEGER is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_HINDEXED_INTEGER is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_HINDEXED_INTEGER;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_HINDEXED_INTEGER, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_HINDEXED], [True if MPI_COMBINER_HINDEXED is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_HINDEXED is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_HINDEXED;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_HINDEXED, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_INDEXED_BLOCK], [True if MPI_COMBINER_INDEXED_BLOCK is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_INDEXED_BLOCK is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_INDEXED_BLOCK;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_INDEXED_BLOCK, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_STRUCT_INTEGER], [True if MPI_COMBINER_STRUCT_INTEGER is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_STRUCT_INTEGER is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_STRUCT_INTEGER;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_STRUCT_INTEGER, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_STRUCT], [True if MPI_COMBINER_STRUCT is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_STRUCT is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_STRUCT;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_STRUCT, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_SUBARRAY], [True if MPI_COMBINER_SUBARRAY is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_SUBARRAY is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_SUBARRAY;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_SUBARRAY, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_DARRAY], [True if MPI_COMBINER_DARRAY is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_DARRAY is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_DARRAY;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_DARRAY, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_F90_REAL], [True if MPI_COMBINER_F90_REAL is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_F90_REAL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_F90_REAL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_F90_REAL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_F90_COMPLEX], [True if MPI_COMBINER_F90_COMPLEX is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_F90_COMPLEX is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_F90_COMPLEX;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_F90_COMPLEX, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_F90_INTEGER], [True if MPI_COMBINER_F90_INTEGER is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_F90_INTEGER is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_F90_INTEGER;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_F90_INTEGER, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMBINER_RESIZED], [True if MPI_COMBINER_RESIZED is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMBINER_RESIZED is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_COMBINER_RESIZED;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMBINER_RESIZED, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_IDENT], [True if MPI_IDENT is defined])
    AC_MSG_CHECKING([whether the constant MPI_IDENT is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_IDENT;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_IDENT, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_CONGRUENT], [True if MPI_CONGRUENT is defined])
    AC_MSG_CHECKING([whether the constant MPI_CONGRUENT is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_CONGRUENT;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_CONGRUENT, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_SIMILAR], [True if MPI_SIMILAR is defined])
    AC_MSG_CHECKING([whether the constant MPI_SIMILAR is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_SIMILAR;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_SIMILAR, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_UNEQUAL], [True if MPI_UNEQUAL is defined])
    AC_MSG_CHECKING([whether the constant MPI_UNEQUAL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_UNEQUAL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_UNEQUAL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_DISTRIBUTE_BLOCK], [True if MPI_DISTRIBUTE_BLOCK is defined])
    AC_MSG_CHECKING([whether the constant MPI_DISTRIBUTE_BLOCK is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_DISTRIBUTE_BLOCK;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_DISTRIBUTE_BLOCK, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_DISTRIBUTE_CYCLIC], [True if MPI_DISTRIBUTE_CYCLIC is defined])
    AC_MSG_CHECKING([whether the constant MPI_DISTRIBUTE_CYCLIC is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_DISTRIBUTE_CYCLIC;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_DISTRIBUTE_CYCLIC, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_DISTRIBUTE_NONE], [True if MPI_DISTRIBUTE_NONE is defined])
    AC_MSG_CHECKING([whether the constant MPI_DISTRIBUTE_NONE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_DISTRIBUTE_NONE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_DISTRIBUTE_NONE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_DISTRIBUTE_DFLT_DARG], [True if MPI_DISTRIBUTE_DFLT_DARG is defined])
    AC_MSG_CHECKING([whether the constant MPI_DISTRIBUTE_DFLT_DARG is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_DISTRIBUTE_DFLT_DARG;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_DISTRIBUTE_DFLT_DARG, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_RDONLY], [True if MPI_MODE_RDONLY is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_RDONLY is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_RDONLY;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_RDONLY, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_RDWR], [True if MPI_MODE_RDWR is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_RDWR is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_RDWR;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_RDWR, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_WRONLY], [True if MPI_MODE_WRONLY is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_WRONLY is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_WRONLY;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_WRONLY, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_CREATE], [True if MPI_MODE_CREATE is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_CREATE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_CREATE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_CREATE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_EXCL], [True if MPI_MODE_EXCL is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_EXCL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_EXCL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_EXCL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_DELETE_ON_CLOSE], [True if MPI_MODE_DELETE_ON_CLOSE is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_DELETE_ON_CLOSE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_DELETE_ON_CLOSE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_DELETE_ON_CLOSE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_UNIQUE_OPEN], [True if MPI_MODE_UNIQUE_OPEN is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_UNIQUE_OPEN is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_UNIQUE_OPEN;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_UNIQUE_OPEN, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_SEQUENTIAL], [True if MPI_MODE_SEQUENTIAL is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_SEQUENTIAL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_SEQUENTIAL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_SEQUENTIAL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_APPEND], [True if MPI_MODE_APPEND is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_APPEND is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_APPEND;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_APPEND, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_SEEK_SET], [True if MPI_SEEK_SET is defined])
    AC_MSG_CHECKING([whether the constant MPI_SEEK_SET is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_SEEK_SET;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_SEEK_SET, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_SEEK_CUR], [True if MPI_SEEK_CUR is defined])
    AC_MSG_CHECKING([whether the constant MPI_SEEK_CUR is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_SEEK_CUR;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_SEEK_CUR, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_SEEK_END], [True if MPI_SEEK_END is defined])
    AC_MSG_CHECKING([whether the constant MPI_SEEK_END is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_SEEK_END;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_SEEK_END, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_NOCHECK], [True if MPI_MODE_NOCHECK is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_NOCHECK is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_NOCHECK;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_NOCHECK, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_NOSTORE], [True if MPI_MODE_NOSTORE is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_NOSTORE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_NOSTORE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_NOSTORE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_NOPUT], [True if MPI_MODE_NOPUT is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_NOPUT is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_NOPUT;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_NOPUT, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_NOPRECEDE], [True if MPI_MODE_NOPRECEDE is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_NOPRECEDE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_NOPRECEDE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_NOPRECEDE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_MODE_NOSUCCEED], [True if MPI_MODE_NOSUCCEED is defined])
    AC_MSG_CHECKING([whether the constant MPI_MODE_NOSUCCEED is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_MODE_NOSUCCEED;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_MODE_NOSUCCEED, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_LOCK_SHARED], [True if MPI_LOCK_SHARED is defined])
    AC_MSG_CHECKING([whether the constant MPI_LOCK_SHARED is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_LOCK_SHARED;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_LOCK_SHARED, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_LOCK_EXCLUSIVE], [True if MPI_LOCK_EXCLUSIVE is defined])
    AC_MSG_CHECKING([whether the constant MPI_LOCK_EXCLUSIVE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_LOCK_EXCLUSIVE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_LOCK_EXCLUSIVE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_ORDER_C], [True if MPI_ORDER_C is defined])
    AC_MSG_CHECKING([whether the constant MPI_ORDER_C is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_ORDER_C;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_ORDER_C, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_ORDER_FORTRAN], [True if MPI_ORDER_FORTRAN is defined])
    AC_MSG_CHECKING([whether the constant MPI_ORDER_FORTRAN is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_ORDER_FORTRAN;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_ORDER_FORTRAN, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_THREAD_SINGLE], [True if MPI_THREAD_SINGLE is defined])
    AC_MSG_CHECKING([whether the constant MPI_THREAD_SINGLE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_THREAD_SINGLE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_THREAD_SINGLE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_THREAD_FUNNELED], [True if MPI_THREAD_FUNNELED is defined])
    AC_MSG_CHECKING([whether the constant MPI_THREAD_FUNNELED is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_THREAD_FUNNELED;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_THREAD_FUNNELED, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_THREAD_SERIALIZED], [True if MPI_THREAD_SERIALIZED is defined])
    AC_MSG_CHECKING([whether the constant MPI_THREAD_SERIALIZED is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_THREAD_SERIALIZED;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_THREAD_SERIALIZED, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_THREAD_MULTIPLE], [True if MPI_THREAD_MULTIPLE is defined])
    AC_MSG_CHECKING([whether the constant MPI_THREAD_MULTIPLE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_THREAD_MULTIPLE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_THREAD_MULTIPLE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_GRAPH], [True if MPI_GRAPH is defined])
    AC_MSG_CHECKING([whether the constant MPI_GRAPH is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_GRAPH;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_GRAPH, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_CART], [True if MPI_CART is defined])
    AC_MSG_CHECKING([whether the constant MPI_CART is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_CART;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_CART, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_UNDEFINED], [True if MPI_UNDEFINED is defined])
    AC_MSG_CHECKING([whether the constant MPI_UNDEFINED is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_UNDEFINED;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_UNDEFINED, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_TYPECLASS_REAL], [True if MPI_TYPECLASS_REAL is defined])
    AC_MSG_CHECKING([whether the constant MPI_TYPECLASS_REAL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_TYPECLASS_REAL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_TYPECLASS_REAL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_TYPECLASS_INTEGER], [True if MPI_TYPECLASS_INTEGER is defined])
    AC_MSG_CHECKING([whether the constant MPI_TYPECLASS_INTEGER is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_TYPECLASS_INTEGER;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_TYPECLASS_INTEGER, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_TYPECLASS_COMPLEX], [True if MPI_TYPECLASS_COMPLEX is defined])
    AC_MSG_CHECKING([whether the constant MPI_TYPECLASS_COMPLEX is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_TYPECLASS_COMPLEX;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_TYPECLASS_COMPLEX, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_TAG_UB], [True if MPI_TAG_UB is defined])
    AC_MSG_CHECKING([whether the constant MPI_TAG_UB is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_TAG_UB;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_TAG_UB, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_HOST], [True if MPI_HOST is defined])
    AC_MSG_CHECKING([whether the constant MPI_HOST is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_HOST;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_HOST, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_IO], [True if MPI_IO is defined])
    AC_MSG_CHECKING([whether the constant MPI_IO is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_IO;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_IO, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_WTIME_IS_GLOBAL], [True if MPI_WTIME_IS_GLOBAL is defined])
    AC_MSG_CHECKING([whether the constant MPI_WTIME_IS_GLOBAL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_WTIME_IS_GLOBAL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_WTIME_IS_GLOBAL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_UNIVERSE_SIZE], [True if MPI_UNIVERSE_SIZE is defined])
    AC_MSG_CHECKING([whether the constant MPI_UNIVERSE_SIZE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_UNIVERSE_SIZE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_UNIVERSE_SIZE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_LASTUSEDCODE], [True if MPI_LASTUSEDCODE is defined])
    AC_MSG_CHECKING([whether the constant MPI_LASTUSEDCODE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_LASTUSEDCODE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_LASTUSEDCODE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_APPNUM], [True if MPI_APPNUM is defined])
    AC_MSG_CHECKING([whether the constant MPI_APPNUM is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_APPNUM;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_APPNUM, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_WIN_BASE], [True if MPI_WIN_BASE is defined])
    AC_MSG_CHECKING([whether the constant MPI_WIN_BASE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_WIN_BASE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_WIN_BASE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_WIN_SIZE], [True if MPI_WIN_SIZE is defined])
    AC_MSG_CHECKING([whether the constant MPI_WIN_SIZE is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_WIN_SIZE;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_WIN_SIZE, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_WIN_DISP_UNIT], [True if MPI_WIN_DISP_UNIT is defined])
    AC_MSG_CHECKING([whether the constant MPI_WIN_DISP_UNIT is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    int value = MPI_WIN_DISP_UNIT;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_WIN_DISP_UNIT, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMM_NULL], [True if MPI_COMM_NULL is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMM_NULL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPI_Comm value = MPI_COMM_NULL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMM_NULL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMM_WORLD], [True if MPI_COMM_WORLD is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMM_WORLD is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPI_Comm value = MPI_COMM_WORLD;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMM_WORLD, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_COMM_SELF], [True if MPI_COMM_SELF is defined])
    AC_MSG_CHECKING([whether the constant MPI_COMM_SELF is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPI_Comm value = MPI_COMM_SELF;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_COMM_SELF, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_GROUP_NULL], [True if MPI_GROUP_NULL is defined])
    AC_MSG_CHECKING([whether the constant MPI_GROUP_NULL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPI_Group value = MPI_GROUP_NULL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_GROUP_NULL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_GROUP_EMPTY], [True if MPI_GROUP_EMPTY is defined])
    AC_MSG_CHECKING([whether the constant MPI_GROUP_EMPTY is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPI_Group value = MPI_GROUP_EMPTY;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_GROUP_EMPTY, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_ERRHANDLER_NULL], [True if MPI_ERRHANDLER_NULL is defined])
    AC_MSG_CHECKING([whether the constant MPI_ERRHANDLER_NULL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPI_Errhandler value = MPI_ERRHANDLER_NULL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_ERRHANDLER_NULL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_REQUEST_NULL], [True if MPI_REQUEST_NULL is defined])
    AC_MSG_CHECKING([whether the constant MPI_REQUEST_NULL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPI_Request value = MPI_REQUEST_NULL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_REQUEST_NULL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_ERROR([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_FILE_NULL], [True if MPI_FILE_NULL is defined])
    AC_MSG_CHECKING([whether the constant MPI_FILE_NULL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPI_File value = MPI_FILE_NULL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_FILE_NULL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_INFO_NULL], [True if MPI_INFO_NULL is defined])
    AC_MSG_CHECKING([whether the constant MPI_INFO_NULL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPI_Info value = MPI_INFO_NULL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_INFO_NULL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPIO_REQUEST_NULL], [True if MPIO_REQUEST_NULL is defined])
    AC_MSG_CHECKING([whether the constant MPIO_REQUEST_NULL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPIO_Request value = MPIO_REQUEST_NULL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPIO_REQUEST_NULL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AH_TEMPLATE([DUMPI_HAVE_MPI_WIN_NULL], [True if MPI_WIN_NULL is defined])
    AC_MSG_CHECKING([whether the constant MPI_WIN_NULL is defined])
    AC_LINK_IFELSE(
      [AC_LANG_PROGRAM(
        [
          #include <mpi.h>
        ], [
	    int *argc;
	    char ***argv;
	    MPI_Win value = MPI_WIN_NULL;
	    MPI_Init(argc, argv);
	    MPI_Finalize();
        ])],
      [
        AC_DEFINE(DUMPI_HAVE_MPI_WIN_NULL, [1])
        AC_MSG_RESULT([yes])
      ], [
        AC_MSG_RESULT([no])
      ]
    )

    AC_LANG_POP
  ]
)
