/** \file
 * Hello world example app.
 * A very simple mpi skeleton application.
 */

#include "sstmac/process/mpiapp.h"
#include "sstmac/process/mpiapi.h"

/// A hello world example mpi skeleton application.
namespace hellocomm {
 
  /** Helloapp is an example mpi skeleton application.  It inherits mpi 
    * support [things like mpiapi()] from mpiapp.  mpiapp is derived from
    * the thread class, so this will be a runnable task thread [it must
    * implement a run() method].
    */

  class helloapp : public sstmac::mpiapp {

  protected:

    /** Protected constructor, public uses helloapp::construct(). */
    helloapp() {};

  public:

    /** Public constructor, creates a reference counted app object. */
    static boost::shared_ptr<helloapp> construct();

    /** Get a copy, launchers can use this to create app threads. */
    boost::shared_ptr<sstmac::mpiapp> clone();

    /** Destructor. */
    virtual ~helloapp() throw() {};

    /** Overrides thread::run virtual function.
      * The task thread context is started by a call into this function. */
    void run();
  };

} // end of namespace hellocomm

