/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_PROCESS_MPICOMMID_H
#define SSTMAC_PROCESS_MPICOMMID_H

#include <iosfwd>

namespace sstmac {

  /// Index assigned to a communicator.
  struct mpicommid {
    int id;
    explicit mpicommid(int idit);
  };

  bool operator==(const mpicommid &a, const mpicommid &b);
  bool operator!=(const mpicommid &a, const mpicommid &b);
  bool operator<(const mpicommid &a, const mpicommid &b);
  bool operator>(const mpicommid &a, const mpicommid &b);
  bool operator<=(const mpicommid &a, const mpicommid &b);
  bool operator>=(const mpicommid &a, const mpicommid &b);

  std::ostream& operator<<(std::ostream &os, const mpicommid &id);

} // end of namespace sstmac

#endif // ! SSTMAC_PROCESS_MPICOMMID_H
