/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_PROCESS_MPIDEST_H
#define SSTMAC_PROCESS_MPIDEST_H

#include <sstmac/process/mpiid.h>

namespace sstmac {

  /**
   * Information about a partner for an mpi send operation.
   * Trying to get stronger typing than is afforded by std::pair.
   */
  struct mpidest {
    mpidest(const mpiid &ddest = mpiid(-1), int ccount = -1) :
      dest(ddest), count(ccount)
    {}

    mpiid dest;
    int   count;
  };

} // end of namespace sstmac

#endif // ! SSTMAC_PROCESS_MPIDEST_H
