/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_PROCESS_MPITAG_H
#define SSTMAC_PROCESS_MPITAG_H

#include <iosfwd>

namespace sstmac {

  /// MPI tag type.
  struct mpitag {
    int id;
    explicit mpitag(int idit = -1);
    bool matches(const mpitag &other) const;

    static const mpitag any_tag;
  };
  bool operator==(const mpitag &a, const mpitag &b);
  bool operator!=(const mpitag &a, const mpitag &b);
  bool operator<(const mpitag &a, const mpitag &b);
  std::ostream& operator<<(std::ostream &os, const mpitag &tag);

} // end of namespace sstmac

#endif // ! SSTMAC_PROCESS_MPITAG_H
