/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_PROCESS_SIMPLEAPP_H
#define SSTMAC_PROCESS_SIMPLEAPP_H

#include <sstmac/process/app.h>

namespace sstmac {

  /**
   * Simple app, used for testing processor model infrasructure
   */
  class simpleapp : public app {

  typedef boost::shared_ptr<computeapi> computeapi_t;

  protected:
    /// Protected constructors
    simpleapp() {}

  public:
    /// Public constructor
    static boost::shared_ptr<app> construct();
    
    /// Goodbye.
    virtual ~simpleapp() throw();
 
    /// Go.
    void run();
  };

} // end of namespace sstmac

#endif // ! SSTMAC_PROCESS_SIMPLEAPP_H
