/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_PROCESS_SIMPLEMPIAPP_H
#define SSTMAC_PROCESS_SIMPLEMPIAPP_H

#include <sstmac/process/mpiapp.h>

namespace sstmac {

  /**
   * Basic test of skeleton apps mixing mpi and processor modeling.
   */
  class simplempiapp : public mpiapp {
  protected:
    /// Hi.
    simplempiapp();

  public:
    /// Hello.
    static boost::shared_ptr<simplempiapp> construct();

    /// Goodbye.
    virtual ~simplempiapp() throw();

    /// Get a copy.
    boost::shared_ptr<mpiapp> clone();

    /// Go.
    void run();
  };

} // end of namespace sstmac

#endif // ! SSTMAC_PROCESS_SIMPLEMPIAPP_H
