/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <sstmac/simulator/networkcalltrap.h>
#include <sstmac/util/errors.h>
#include <sstmac/util/debug.h>

namespace sstmac {

  using boost::shared_ptr;

  //
  // Schedule a send.
  //
  void networkcalltrap::send(const timestamp &start_time,
                             const ppid &the_process,
                             const nodeid &the_recver,
                             const shared_ptr<networkdata> &the_payload,
                             const shared_ptr<eventhandler> &the_sendevent)
  {
    throw unimplementederror("networkcalltrap: send call trapped");
  }

} // end of namespace sstmac.
