/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

%module sstmac_process

%{
#include <sstmac/process/mpiapp.h>
%}

#if SWIG_VERSION >= 0x020000
%shared_ptr(sstmac::mpiapp);
#else
SWIG_SHARED_PTR_DERIVED(mpiappptr, sstmac::thread, sstmac::mpiapp);
#endif

%include sstmac/swig/process/thread.i
%include sstmac/swig/process/mpiapi.i
%include sstmac/swig/process/app.i

%include sstmac/process/mpiapp.h

