/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

%module sstmac_process

%{
#include <sstmac/process/mpilaunch.h>
%}

#if SWIG_VERSION >= 0x020000
%shared_ptr(sstmac::mpilaunch);
#else
SWIG_SHARED_PTR_DERIVED(mpilaunchptr, sstmac::applaunch, sstmac::mpilaunch);
#endif

%import sstmac/swig/simulator/launcher.i

%include sstmac/swig/process/applaunch.i
%include sstmac/swig/process/mpistrategy.i
%include sstmac/swig/process/mpicommfactory.i
%include sstmac/swig/process/scheduler.i
%include sstmac/swig/process/mpiapp.i
%include sstmac/swig/process/mpiapi.i

%include sstmac/process/mpilaunch.h

