/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

%module sstmac_process

%{
#include <sstmac/process/mpirecvengine.h>
%}

#if SWIG_VERSION >= 0x020000
%shared_ptr(sstmac::mpirecvengine);
#else
SWIG_SHARED_PTR_DERIVED(mpirecvengineptr, sstmac::mpikernel, sstmac::mpirecvengine);
#endif

%include sstmac/swig/process/mpikernel.i
%include sstmac/swig/process/mpirecv.i
%include sstmac/swig/process/mpimessage.i
%include sstmac/swig/process/mpiqueue.i

%include sstmac/process/mpirecvengine.h

