/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

%module sstmac_process

%{
#include <sstmac/process/mpiscanengine.h>
%}

#if SWIG_VERSION >= 0x020000
%shared_ptr(sstmac::mpiscanengine);
#else
SWIG_SHARED_PTR_DERIVED(mpiscanengineptr, sstmac::mpicollective, sstmac::mpiscanengine);
#endif

%import sstmac/swig/util/topologyiterator.i

%include sstmac/swig/process/mpicollective.i
%include sstmac/swig/process/mpitype.i
%include sstmac/swig/process/mpitag.i
%include sstmac/swig/process/mpicomm.i
%include sstmac/swig/process/mpiqueue.i
%include sstmac/swig/process/mpistatus.i

%include sstmac/process/mpiscanengine.h

