/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

%module sstmac_process

%{
#include <sstmac/process/recvhandler.h>
%}

#if SWIG_VERSION >= 0x020000
%shared_ptr(sstmac::recvhandler);
#else
SWIG_SHARED_PTR_DERIVED(recvhandlerptr, sstmac::eventhandler, sstmac::recvhandler);
#endif

%import sstmac/swig/simulator/eventhandler.i
%import sstmac/swig/simulator/nodeid.i
%import sstmac/swig/simulator/ppid.i
%import sstmac/swig/simulator/networkdata.i
%import sstmac/swig/simulator/node.i

%include sstmac/process/recvhandler.h

