/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

%module sstmac_simulator

%{
#include <sstmac/simulator/launchhandler.h>
%}

#if SWIG_VERSION >= 0x020000
%shared_ptr(sstmac::launchhandler);
#else
SWIG_SHARED_PTR_DERIVED(launchhandlerptr, sstmac::eventhandler, sstmac::launchhandler);
#endif

%include sstmac/swig/simulator/launcher.i
%include sstmac/swig/simulator/eventhandler.i

%include sstmac/simulator/launchhandler.h

