/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

%module sstmac_simulator

%{
#include <sstmac/simulator/networkinterface.h>
%}

#if SWIG_VERSION >= 0x020000
%shared_ptr(sstmac::networkinterface);
#else
SWIG_SHARED_PTR(networkinterfaceptr, sstmac::networkinterface);
#endif

%include sstmac/swig/simulator/timestamp.i
%include sstmac/swig/simulator/nodeid.i
%include sstmac/swig/simulator/ppid.i
%include sstmac/swig/simulator/networkdata.i
%include sstmac/swig/simulator/eventhandler.i

%include sstmac/simulator/networkinterface.h
