/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

%module sstmac_simulator

%{
#include <sstmac/simulator/overcommit_flower.h>
%}

#if SWIG_VERSION >= 0x020000
%shared_ptr(sstmac::overcommit_flower);
#else
SWIG_SHARED_PTR_DERIVED(overcommit_flowerptr, sstmac::flower, sstmac::overcommit_flower);
#endif

%include sstmac/swig/simulator/timestamp.i
%include sstmac/swig/simulator/flower.i

%include sstmac/simulator/overcommit_flower.h

