/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

%module sstmac_util

%{
#include <sstmac/util/normaldist.h>
%}

#if SWIG_VERSION >= 0x020000
%shared_ptr(sstmac::RNG::normaldist);
%shared_ptr(sstmac::RNG::boxmuller);
#else
SWIG_SHARED_PTR(normaldistptr, sstmac::RNG::normaldist);
SWIG_SHARED_PTR_DERIVED(boxmullerptr, sstmac::RNG::normaldist, sstmac::RNG::boxmuller);
#endif

%include sstmac/swig/util/rng.i
%include sstmac/util/normaldist.h

